package cn.tursom.web.utils

import cn.tursom.core.datastruct.StringRadixTree

object ContextTypeMap {
  private val router = StringRadixTree<String>()
  operator fun get(type: String) = router[type.substringAfterLast('.')]

  init {
    router["aac"] = "audio/aac"
    router["abw"] = "application/x-abiword"
    router["arc"] = "application/x-freearc"
    router["avi"] = "video/x-msvideo"
    router["azw"] = "aapplication/vnd.amazon.ebook"
    router["bin"] = "application/octet-stream"
    router["bmp"] = "image/bmp"
    router["bz"] = "application/x-bzip"
    router["bz2"] = "application/x-bzip2"
    router["csh"] = "application/x-csh"
    router["css"] = "itext/css; charset=UTF-8"
    router["csv"] = "itext/csv; charset=UTF-8"
    router["doc"] = "application/msword"
    router["docx"] = "application/vnd.openxmlformats-officedocument.wordprocessingml.document"
    router["eot"] = "application/vnd.ms-fontobject"
    router["epub"] = "application/epub+zip"
    router["gif"] = "image/gif"
    router["html"] = "text/html; charset=UTF-8"
    router["htm"] = "text/html; charset=UTF-8"
    router["ico"] = "image/vnd.microsoft.icon"
    router["ics"] = "text/calendar; charset=UTF-8"
    router["jar"] = "application/java-archive"
    router["jpeg"] = "image/jpeg"
    router["jpg"] = "image/jpeg"
    router["js"] = "text/javascript; charset=UTF-8"
    router["json"] = "application/json; charset=UTF-8"
    router["jsonld"] = "application/ld+json"
    router["mid"] = "audio/midi"
    router["midi"] = "audio/midi"
    router["mjs"] = "text/javascript"
    router["mp3"] = "audio/mpeg"
    router["mp4"] = "audio/mp4"
    router["mpeg"] = "video/mpeg"
    router["mpkg"] = "application/vnd.apple.installer+xml"
    router["odp"] = "application/vnd.oasis.opendocument.presentation"
    router["ods"] = "application/vnd.oasis.opendocument.spreadsheet"
    router["odt"] = "application/vnd.oasis.opendocument.text"
    router["oga"] = "audio/ogg"
    router["ogg"] = "application/ogg"
    router["ogv"] = "video/ogg"
    router["ogx"] = "application/ogg"
    router["otf"] = "font/otf"
    router["png"] = "image/png"
    router["pdf"] = "application/pdf"
    router["ppt"] = "application/vnd.ms-powerpoint"
    router["pptx"] = "application/vnd.openxmlformats-officedocument.presentationml.presentation"
    router["rar"] = "application/x-rar-compressed"
    router["rtf"] = "application/rtf"
    router["sh"] = "application/x-sh"
    router["svg"] = "image/svg+xml"
    router["swf"] = "application/x-shockwave-flash"
    router["tar"] = "application/x-tar"
    router["tif"] = "image/tiff"
    router["tiff"] = "image/tiff"
    router["ttf"] = "font/ttf"
    router["txt"] = "text/plain; charset=UTF-8"
    router["vsd"] = "application/vnd.visio"
    router["wav"] = "audio/wav"
    router["weba"] = "audio/webm"
    router["webm"] = "video/webm"
    router["webp"] = "image/webp"
    router["woff"] = "font/woff"
    router["woff2"] = "font/woff2"
    router["xhtml"] = "application/xhtml+xml"
    router["xls"] = "application/vnd.ms-excel"
    router["xlsx"] = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
    router["xml"] = "text/xml; charset=UTF-8"
    router["xul"] = "application/vnd.mozilla.xul+xml"
    router["zip"] = "application/zip"
    router["3gp"] = "video/3gpp"
    router["3g2"] = "ivideo/3gpp2"
    router["7z"] = "application/x-7z-compressed"
  }
}


